//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


#define FLAG_CONTROL              0x4354524c
#define FLAG_WAVEFORM             0x29bd932f
#define FLAG_TRANSMIT             0x93a2f432

#define CMD_ONOFF                 0
#define CMD_WORKMODE              1

#define VALUE_ON                  1
#define VALUE_OFF                 0

#define WORKMODE_38K              0    //38KԶ;
#define WORKMODE_WIDE             1    //Ƶ߾
#define WORKMODE_NOCARRIER        2    //ز߾
#define WORKMODE_CARRIER          3    //ز
#define WORKMODE_56K              4    //56KԶ;(YG-920 V10.0 YG-2210B֧)

//------------------------------------------------------------------        
typedef struct _ir_data
{
   int type;                    //0-->ͨң,1--->յң,2--->Զ,3--->źǿ
   unsigned __int64 sys_code;   //ͻ(յңԶң޿ͻ)
   unsigned __int64 data_code;  //(յңԶң޼)
   int sys_len;                 //ͻλ(յңԶң̶Ϊ0)
   int data_len;                //λ(յңԶң̶Ϊ0)
   int code_time;               //볤
   char format[50];             //ʽ
   char full_code[255];         //ȫ
   int wave_len;                //γ
   unsigned int wave_buf[2048];      //
   int frequency;               //زƵ   Hz,  źǿģʽЧ
   int amplitude;               //źŷȣλmV,   źǿģʽЧ
}IR_DATA;

char *remote_type[] = {"ͨң","յң","Զң","źǿ"};

typedef struct _transmit_data
{
 int frequency;             //زƵ   Hz
 int duty;                  //ռձ
 int display;               //Ƿڴʾ
 int wave_len;              //γ
 unsigned int wave_buf[2048];   //
}TRANSMIT_DATA;


TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TfmMain::GetData(TMessage &Message)
{
 IR_DATA *ir;
 COPYDATASTRUCT *ds;
 ds=(COPYDATASTRUCT *)Message.LParam;

 ir = (IR_DATA *)ds->lpData;

 Edit6->Text = remote_type[ir->type];
 Edit1->Text = ir->format;
 Edit2->Text = (ir->sys_len == 0) ? AnsiString("") : IntToHex((__int64)ir->sys_code,(ir->sys_len + 3)/4);
 Edit3->Text = (ir->data_len == 0) ? AnsiString("") : IntToHex((__int64)ir->data_code,(ir->data_len + 3)/4);
 Edit4->Text = ir->full_code;
 Edit5->Text = IntToStr(ir->code_time);

 Edit7->Text = FormatFloat("0.00KHz",ir->frequency/1000.0);
 Edit8->Text = FormatFloat("0.00V",ir->amplitude/1000.0);

 Memo1->Clear();

 for(int i = 0;i < ir->wave_len;i++) Memo1->Lines->Add(IntToStr(ir->wave_buf[i]));

}
//=========================================================================
HWND MyFindWindow()
{
 HWND hPrevWnd, hData;

 CreateMutex (NULL, true, "IROffice") ;

 if (GetLastError()== ERROR_ALREADY_EXISTS)
  {//ShowMessage ("ݲɼУ") ;
   hPrevWnd = GetDesktopWindow();
   hPrevWnd = GetWindow(hPrevWnd, GW_CHILD);
   while (IsWindow(hPrevWnd))
    {
     //жϴ˴Ա־Ƿõڻ¼ڱ־.
     hData = GetProp(hPrevWnd, "IROffice");
     if (hData == (void *)1)  return  hPrevWnd;  //ҵ<ңعϵͳ>

     hPrevWnd = GetWindow(hPrevWnd, GW_HWNDNEXT);
    }
  }

 CreateMutex (NULL, true, "IRReader") ;

 if (GetLastError()== ERROR_ALREADY_EXISTS)
  {//ShowMessage ("ݲɼУ") ;
   hPrevWnd = GetDesktopWindow();
   hPrevWnd = GetWindow(hPrevWnd, GW_CHILD);
   while (IsWindow(hPrevWnd))
    {
     //жϴ˴Ա־Ƿõڻ¼ڱ־.
     hData = GetProp(hPrevWnd, "IRReader");
     if (hData == (void *)1)  return  hPrevWnd;  //ҵ<ңر>

     hPrevWnd = GetWindow(hPrevWnd, GW_HWNDNEXT);
    }
  } 
  
 return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btnOpenClick(TObject *Sender)
{

 HWND Hd; 
 COPYDATASTRUCT ds;
 int buf[2];
 
 Hd = MyFindWindow();
 
 if(Hd == NULL)
  {
   ShowMessage("ңرû.");
   return;
  }

 buf[0] = CMD_ONOFF;          //ָ
 buf[1] = VALUE_ON;           //

 ds.dwData = FLAG_CONTROL;    //Ʊ־
 ds.cbData = sizeof(buf);
 ds.lpData = buf;

 if(SendMessage(Hd, WM_COPYDATA, (int)Handle, (LPARAM) (PCOPYDATASTRUCT) &ds) != 0)  StatusBar1->SimpleText = "򿪳ɹ.";
 
 else StatusBar1->SimpleText = "ʧ.";


}
//---------------------------------------------------------------------------

void __fastcall TfmMain::btnCloseClick(TObject *Sender)
{
 HWND Hd;
 COPYDATASTRUCT ds;
 int buf[2];

 
 Hd = MyFindWindow();
 
 if(Hd == NULL)
  {
   ShowMessage("ңرû.");
   return;
  }

 buf[0] = CMD_ONOFF;          //ָ
 buf[1] = VALUE_OFF;           //

 ds.dwData = FLAG_CONTROL;    //Ʊ־
 ds.cbData = sizeof(buf);
 ds.lpData = buf;

 if(SendMessage(Hd, WM_COPYDATA, (int)Handle, (LPARAM) (PCOPYDATASTRUCT) &ds) != 0)  StatusBar1->SimpleText = "رճɹ.";
 
 else StatusBar1->SimpleText = "رʧ.";
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::rgWorkModeClick(TObject *Sender)
{
 HWND Hd;
 COPYDATASTRUCT ds;
 int buf[2];
 
 Hd = MyFindWindow();
 
 if(Hd == NULL)
  {
   ShowMessage("ңرû.");
   return;
  }

 buf[0] = CMD_WORKMODE;           //ģʽ
 buf[1] = rgWorkMode->ItemIndex;  //ģʽ

 ds.dwData = FLAG_CONTROL;        //Ʊ־
 ds.cbData = sizeof(buf);
 ds.lpData = buf;

 if(SendMessage(Hd, WM_COPYDATA, (int)Handle, (LPARAM) (PCOPYDATASTRUCT) &ds) != 0)  StatusBar1->SimpleText = "òģʽɹ.";
 
 else StatusBar1->SimpleText = "òģʽʧ.";
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Button1Click(TObject *Sender) 
{
   
 HWND Hd; 
 COPYDATASTRUCT ds;

 int Waveform[] = {9000,4500,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,100000};         //Unit: us
 
 Hd = MyFindWindow();
 
 if(Hd == NULL)
  {
   ShowMessage("ңرû.");
   return;
  }

 ds.dwData = FLAG_WAVEFORM;    //Ʊ־
 ds.cbData = sizeof(Waveform);
 ds.lpData = Waveform;

 if(SendMessage (Hd, WM_COPYDATA, (int)Handle, (LPARAM) (PCOPYDATASTRUCT) &ds) != 0) StatusBar1->SimpleText = "ͳɹ";
 else StatusBar1->SimpleText = "ʧܣûYG-920";

}
//---------------------------------------------------------------------------

TRANSMIT_DATA td;

void __fastcall TfmMain::Button2Click(TObject *Sender)
{
   
 HWND Hd; 
 COPYDATASTRUCT ds;

 unsigned int Waveform[] = {9000,4500,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,560,560,1680,560,100000};         //Unit: us
 
 Hd = MyFindWindow();
 
 if(Hd == NULL)
  {
   ShowMessage("ңرû.");
   return;
  }

 td.frequency = 38000;     //38KHz
 td.duty = 30;             //30%
 td.display = 1;
 td.wave_len = sizeof(Waveform) / sizeof(Waveform[0]);
 memcpy(td.wave_buf,Waveform,sizeof(Waveform));


 ds.dwData = FLAG_TRANSMIT;    //Ʊ־
 ds.cbData = sizeof(td);
 ds.lpData = &td;

 if(SendMessage (Hd, WM_COPYDATA, (int)Handle, (LPARAM) (PCOPYDATASTRUCT) &ds) != 0) StatusBar1->SimpleText = "ͳɹ";
 else StatusBar1->SimpleText = "ʧܣûYG-920";        
}
//---------------------------------------------------------------------------

